<?php
///////////////////////////////////////
//
// Sneddie's .mp3 linker 1.1 beta 1- Indexes MP3 releases.
// Copyright (C) 2001-2002  Craig Edwards
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
///////////////////////////////////////
//                                                                                                
// DO NOT CHANGE ANYTHING BELOW THIS POINT! 
// .. unless of course you know what you are doing ;)    
//
// LOAD CONFIG

include("mp3linker.conf");

//
// DEFINES
//

define("VFS_LIMIT_REACHED", 2);
                                                                                                 
/////////////////////
// FUNCTIONS START

//
// Read and return the year from the .mp3 files ID3v1 tag..
//
function read_id3v1_year($mp3_path)
{

    // Open the mp3 file..
    $mp3_fp = fopen ("$mp3_path", "rb");
    $mp3_size = filesize("$mp3_path");
  
    // Jump to the ID3 tag (last 128bytes)..
    fseek($mp3_fp, $mp3_size-128);
    $tag_check = fread($mp3_fp, 3);
    
    // Check to see if the .mp3 has a ID3v1 tag..
    if($tag_check == "TAG")
    {    
        // Jump to 4 bytes where year is stored and read..
        fseek($mp3_fp, $mp3_size-35);
        $year = fread($mp3_fp, 4);  
    }
    else
    {
        $year = "Unknown";
    }      
    
    fclose($mp3_fp);
	
	// Lets check the date is valid! We only want 4 digit years!
	if(!eregi("[0-9]{4}", $year))
	{
	    $year = "Unknown";
    }
    
    return $year;
    
} // read_id3v1_year();


//
// Read and return the genre from the .mp3 files ID3v1 tag..
//
function read_id3v1_genre($mp3_path)
{

    // Associate array made static (so it doesn't get created every time the function is called) which contains the different id3 genres.
    // Includes the id3 specs + winamp extensions.
    static $mp3_genre_list = array(
    
        0 => "Blues", 1 => "Classic Rock", 2 => "Country", 3 => "Dance", 4 => "Disco", 5 => "Funk", 6 => "Grunge", 7 => "Hip-Hop",
        8 => "Jazz", 9 => "Metal", 10 => "New_Age", 11 => "Oldies", 12 => "Other", 13 => "Pop", 14 => "R_&_B", 15 => "Rap", 16 => "Reggae",
        17 => "Rock", 18 => "Techno", 19 => "Industrial", 20 => "Alternative", 21 => "Ska", 22 => "Death_Metal", 23 => "Pranks", 24 => "Soundtrack",
        25 => "Euro-Techno", 26 => "Ambient", 27 => "Trip-Hop", 28 => "Vocal", 29 => "Jazz_Funk", 30 => "Fusion", 31 => "Trance", 32 => "Classical",
        33 => "Instrumental", 34 => "Acid", 35 => "House", 36 => "Game", 37 => "Sound_Clip", 38 => "Gospel", 39 => "Noise", 40 => "Alternative_Rock",
        41 => "Bass", 42 => "Soul", 43 => "Punk", 44 => "Space", 45 => "Meditative", 46 => "Instrumental_Pop", 47 => "Instrumental_Rock", 48 => "Ethnic",
        49 => "Gothic", 50 => "Darkwave", 51 => "Techno-Industrial", 52 => "Electronic", 53 => "Pop-Folk", 54 => "Eurodance", 55 => "Dream", 
        56 => "Southern_Rock", 57 => "Comedy", 58 => "Cult", 59 => "Gangsta", 60 => "Top_40", 61 => "Christian_Rap", 62 => "Pop_Funk", 63 => "Jungle",
        64 => "Native_American",65 => "Cabaret", 66 => "New_Wave", 67 => "Psychadelic", 68 => "Rave", 69 => "Showtunes", 70 => "Trailer", 71 => "Lo-Fi",
        72 => "Tribal", 73 => "Acid_Punk", 74 => "Acid_Jazz", 75 => "Polka", 76 => "Retro", 77 => "Musical", 78 => "Rock_&_Roll",  79 => "Hard_Rock",
        80 => "Folk", 81 => "Folk-Rock", 82 => "National_Folk", 83 => "Swing", 84 => "Fast_Fusion", 85 => "Bebob", 86 => "Latin", 87 => "Revival",
        88 => "Celtic", 89 => "Bluegrass", 90 => "Avantgrade", 91 => "Gothic_Rock", 92 => "Progressive_Rock", 93 => "Psychedelic_Rock",
        94 => "Symphonic_Rock", 95 => "Slow_Rock", 96 => "Big_Band", 97 => "Chorus", 98 => "Easy_Listening", 99 => "Acoustic", 100 => "Humour",
        101 => "Speech", 102 => "Chanson", 103 => "Opera", 104 => "Chamber_Music", 105 => "Sonata", 106 => "Symphony", 107 => "Booty_Bass",
        108 => "Primus", 109 => "Porn_Groove", 110 => "Satire", 111 => "Slow_Jam", 112 => "Club", 113 => "Tango", 114 => "Samba", 115 => "Folklore",
        116 => "Ballad", 117 => "Power_Ballad", 118 => "Rhythmic_Soul", 119 => "Freestyle", 120 => "Duet", 121 => "Punk_Rock", 122 => "Drum_Solo",
        123 => "A_capella", 124 => "Euro-House", 125 => "Dance_Hall", 126 => "Goa", 127 => "Drum_&_Bass", 128 => "Club-House", 129 => "Hardcore",
        130 => "Terror", 131 => "Indie", 132 => "BritPop", 133 => "Negerpunk", 134 => "Polsk_Punk", 135 => "Beat", 136 => "Christian_Gangsta",
        137 => "Heavy_Metal", 138 => "Black_Metal", 139 => "Crossover", 140 => "Contemporary_Classical", 141 => "Christian_Rock", 142 => "Merengue",
        143 => "Salsa", 144 => "Thrash_Metal", 145 => "Anime", 146 => "JPop", 147 => "SynthPop"       
    );
    
    // Open the mp3 file..
    $mp3_fp = fopen ("$mp3_path", "rb");
    $mp3_size = filesize("$mp3_path");
  
    // Jump to the ID3 tag.. (last 128bytes)..
    fseek($mp3_fp, $mp3_size-128);
    $tag_check = fread($mp3_fp, 3);
    
    // Check to see if the .mp3 has a ID3v1 tag..
    if($tag_check == "TAG")
    {
        // Jump to byte where genre is stored..
        fseek($mp3_fp, $mp3_size-1);
       
        // Need to convert the byte read from the .mp3 into its ASCII value before looking it up in the list..
        $genre = fread($mp3_fp, 1);
        $genre_ascii = ord($genre);
      
        // Check to make sure the genre number returned is in the array..
        if($genre_ascii > 0 && $genre_ascii < 147) {
            $genre = $mp3_genre_list[$genre_ascii];
        } else {
            $genre = "Unknown";
        }       
    }
    else
    {
        $genre = "Unknown";
    }
    
    fclose($mp3_fp);

    return $genre;
 
} // read_id3v1_genre();

// Deletes a dir strucutre including all the files in the dirs..
// NOTE: This fucntion is recursive.
//
// Thanks to the guy @ www.php.net for this, I just copied it straigh from there! ;P
function recursive_rmdir($dir)
{ 
    
    // Is this a directory?
    if(!is_dir($dir) || !file_exists($dir))
    {
    	return false;
    } 

    $directory = opendir($dir); 
   
    // Skip the "." and ".." files, this increases speed slightly.
    readdir($directory); 
    readdir($directory); 

    // Climb to the top of the directory tree, once there delete it.
    while(false !== ($dir_entry = readdir($directory)))
    { 
        if (is_dir($dir.'\\'.$dir_entry))
        { 
            recursive_rmdir($dir.'\\'.$dir_entry); 
        }
        else
        { 
            unlink($dir.'\\'.$dir_entry); 
        } 
    } 

    closedir($directory); 
    unset($directory); 

    if (rmdir($dir))
    { 
        return true; 
    }
    else
    { 
        return false; 
    } 

}  // recursive_rmdir();

// Move through each dir.. collecting data on each release and storing it in a 2D array.
// NOTE: this function is recursive.
function transverse_dir($dirname)
{

    global $g_releases_list, $OUTPUT;
    
    static $dir_done = false;
    
    $dir_handle = opendir($dirname); 

    // Skip the "." and ".." files, this increases speed slightly.
    readdir($dir_handle);
    readdir($dir_handle);
    
    while( false !== ($file = readdir($dir_handle)) )
    {
     
        // If the "file" is a dir, then enter it.
        if(is_dir($dirname.'\\'.$file))
        {          
            $dir_done = false;
            transverse_dir($dirname.'\\'.$file);
        } 
        // Ignore all files in the dir unless they are an .mp3...
        elseif(eregi("\.mp3", $file))
        {
            //.. and the dir hasn't been visisted before.
            while(!$dir_done)
            {        
                $release_name = substr($dirname, (strrpos($dirname, '\\')+1));      
                
                // Handle multiple CD releases..
                // Only works if the CD dirs begin with CD or DISC (case insensitive)
                if(eregi("^CD[ ]*[0-9]+|^DISC[ ]*[0-9]+", $release_name, $part))
                {                          
                    $mp3_dirname = dirname($dirname);
                    $release_name = substr($mp3_dirname, (strrpos($mp3_dirname, '\\')+1));
                    $mp3_file = $part[0].'\\'.$file;                   
                }
                else
                {
                    $mp3_file = $file;
                    $mp3_dirname = $dirname;
                }               
                
                // If the release is nuked, then dont bother recoding info on it.
                if(stristr($release_name, 'nuked'))
                {
                    $dir_done = true;
                    break;
                }
        
                // Create 2D array, which holds all the release information.                      
                $g_releases_list[count($g_releases_list)] = array(
                  
                    'path' => $mp3_dirname,     // physical path of release
                    'release' => $release_name, // name of release (dir name)
                    'mp3' => $mp3_file,         // filename of an .mp3 file in release
                  
                );
                
                $dir_done = true;
                
                if($OUTPUT) print('.');

            }                   
        
        } 
  
    } 

    closedir($dir_handle); 

} // transverse_dir()

//
// Checks for a previous link tree, deletes it. Ready for a new link tree.
//
function create_link_tree($path)
{

    global $OUTPUT;
    
    // Previous link tree?
    if(file_exists($path))
    {
        if($OUTPUT) print('..Deleting previous link tree..');
        
        // Delete link tree..
        $rmdir_result = recursive_rmdir($path);
        
        // Success? Make new root..
        if($rmdir_result)
        {
            $mkdir_type = mkdir($path, 0744);
            
            if(!$mkdir_type)
            {
                return false;
            }
            
            if($OUTPUT) print("..done\n\n");
        }
    }
    else
    {
        // Make root..
        $mkdir_type = mkdir($path, 0744);
        
        if(!$mkdir_type)
        {
            return false;
        }
    }   
    
    return true;
    
} // delete_previous_link_tree();


function create_link($TYPE, $link, $release, $path)
{
    // List of global variables needed to create the links..
    global ${$TYPE."_DIR"}, ${$TYPE."_VFS_DIR"}, $RAIDENFTPD_VFS_PATH, $RAIDENFTPD_VFS, $VFS_FP, $VFS_OWNER, $VFS_OWNER_GROUP, $VFS_CHMOD, $OUTPUT, $g_link_total;
     
    // Does the link category already exist? If it doesn't create it..
    if( !(file_exists(${$TYPE."_DIR"}."\\".$link)) )
    {
        if($OUTPUT) print("..Creating ".$link." directory..");
        $mkdir_cat = mkdir(${$TYPE."_DIR"}."\\".$link, 0744);
        if($mkdir_cat)
        {
            if($OUTPUT) print("..done\n");
        }
        else
        {
            if($OUTPUT) print("..failed\n");
            return false;
        }                
    }
    
    // Does the link release dir already exists? If so then it must be a multi CD release so skip it.
    // Otherwise make the dir and add the entry to the .vfs file..
    if( !(file_exists(${$TYPE."_DIR"}."\\".$link."\\".$release)) )
    {       
        // Create the link release dir..
        $mkdir_link = mkdir(${$TYPE."_DIR"}."\\".$link."\\".$release, 0744); 
        if(!$mkdir_link)
        {
            return false;
        }
                          
        // Update the .vfs file..                      
        fputs($VFS_FP, $path.'|'.${$TYPE."_VFS_DIR"}.'/'.$link.'/'.$release.'|'.$VFS_OWNER.'|'.$VFS_OWNER_GROUP.'|'.$VFS_CHMOD."|r|0|0|0|0|0|\n");
        
        $g_link_total++;    // Increment the total link counter.  
    }
     
	return true;
	
} // create_link();

function create_alpha_links()
{
    
    global $g_releases_list, $g_link_total, $ALPHA_DIR, $ALPHA_DIR_CASE, $VFS_LIMIT, $VFS_ENTRIES, $OUTPUT;
    
    $counter = 0;
    
    // Check for the ALPHA root..
    if(!create_link_tree($ALPHA_DIR))
    {
        return false;
    }
        
    foreach($g_releases_list as $release)
    {    
        // Extract the artist from the release name dir..
        // If the release name has "VA" or "Various" in it, link it under the "Various" dir instread of "V"..
        if(eregi("^[V][A][-_. ]|^[V]arious[-_. ]|^[V][_.][A][.-_ ]", $release['release']))
        {
            $link = "Various";
        }
        elseif(eregi("[a-zA-Z0-9]", $release['release'], $part))
        {
            // What kind of case does the user want the alpha dirs created as ?
            if(stristr($ALPHA_DIR_CASE, "LOWER"))
            {
                $link = strtolower($part[0]);
            }
            else
            {
                $link = strtoupper($part[0]);  
            }
        }        
        
        // Create link dir, and update .vfs file..
        if(create_link('ALPHA', $link, $release['release'], $release['path']))
        { 
            $counter++;
        }
        else
        {
            return false;
        }
        
        // Check to see if the maximum number of entries in the .vfs has been reached.           
        if($g_link_total == (($VFS_LIMIT-$VFS_ENTRIES)-2))
        {
                return VFS_LIMIT_REACHED;
        }                   
    }
    
    if($OUTPUT) print("\n.. $counter links created under link category.\n\n");
    
    return true;
    
} // create_alpha_links()

function create_genre_links()
{
    
    global $g_releases_list, $g_link_total, $GENRE_DIR, $GENRE_UNKNOWN_DIR, $VFS_LIMIT, $VFS_ENTRIES, $OUTPUT;
    
    $counter = 0;
    
    // Check for the GENRE root..
    if(!create_link_tree($GENRE_DIR))
    {
        return false;
    }
    
    foreach($g_releases_list as $release)
    {
        // Extract the .mp3s genre from the ID3 tag..
        $link = read_id3v1_genre($release['path'].'\\'.$release['mp3']);   
        
        // If the user doesn't want Unkown links created, skip to the next release..
        if($link == "Unknown" && !$GENRE_UNKNOWN_DIR)
        {
            continue;
        }
        else
        {
            // Create link dir, and update .vfs file..
            if(create_link('GENRE', $link, $release['release'], $release['path']))
            {
                $counter++;
            }
            else
            {
                return false;
            }
            
            // Check to see if the maximum number of entries in the .vfs has been reached.           
            if($g_link_total == (($VFS_LIMIT-$VFS_ENTRIES)-2))
            {
                return VFS_LIMIT_REACHED;
            }       
        }                  
    }
    
    if($OUTPUT) print("\n.. $counter links created under link category.\n\n");
    
    return true;
    
} // create_genre_links();

function create_group_links()
{
    
    global $g_releases_list, $g_link_total, $GROUP_DIR, $GROUP_UNKNOWN_DIR, $VFS_LIMIT, $VFS_ENTRIES, $OUTPUT;
   
    $counter = 0;   // Counts the number of links created in this category..
    
    // Check for the GROUP root..
    if(!create_link_tree($GROUP_DIR))
    {
        return false;
    }
    
    foreach($g_releases_list as $release)
    {   
        // Extract the release group from the release dir name, looks after the last -..
        // If it can't find a release group it links it as "Unknown".
        if(eregi("-([a-zA-Z0-9_]+$)", $release['release'],$part))
        {
            $link = $part[1];
        }
        else
        {
            $link = "Unknown";
        }
        
        // If the user doesn't want Unkown links created, skip to the next release..
        if($link == "Unknown" && !$GROUP_UNKNOWN_DIR)
        {
            continue;
        }
        else
        {
            // Create link dir, and update .vfs file..
            if(create_link('GROUP', $link, $release['release'], $release['path']))
            {
                $counter++;
            }
            else
            {
                return false;
            }
            
            // Check to see if the maximum number of entries in the .vfs has been reached.           
            if($g_link_total == (($VFS_LIMIT-$VFS_ENTRIES)-2))
            {
                return VFS_LIMIT_REACHED;
            }       
        }                
    }
    
    if($OUTPUT) print("\n.. $counter links created under link category.\n\n");
    
    return true;
    
}

function create_year_links()
{
    global $g_releases_list, $g_link_total, $YEAR_DIR, $YEAR_UNKNOWN_DIR, $VFS_LIMIT, $VFS_ENTRIES, $OUTPUT;
   
    $counter = 0;   // Counts the number of links created in this category..
    
    // Check for the ALPHA root..
    if(!create_link_tree($YEAR_DIR))
    {
        return false;
    }
    
    foreach($g_releases_list as $release)
    {
        
        $link = read_id3v1_year($release['path'].'\\'.$release['mp3']);
        
        // If the user doesn't want Unkown links created, skip to the next release..
        if($link == "Unknown" && !$YEAR_UNKNOWN_DIR)
        {
            continue;
        }
        else
        {
            // Create link dir, and update .vfs file..
            if(create_link('YEAR', $link, $release['release'], $release['path']))
            {
                $counter++;
            }
            else
            {
                return false;
            }
            
            // Check to see if the maximum number of entries in the .vfs has been reached.           
            if($g_link_total == (($VFS_LIMIT-$VFS_ENTRIES)-2))
            {
                return VFS_LIMIT_REACHED;
            }       
        }                  
    }
    
    if($OUTPUT) print("\n.. $counter links created under link category.\n\n");
    
    return true;
    
}

//
// FUNCTIONS END
//
////////////////////////////////////////
////////////////////////////////////////
//
// MAIN PROGRAM LOOP START
//

$g_releases_list = array(); // Global array, which holds all the different releases information.
$g_link_total = 0;          // Global variable, keeps track of the number of links created.

set_time_limit($TIMEOUT);   // Reset the timeout limit to that specified in the config.

// Move through each of the releases dirs recursivly gathering information on the releases..
if($OUTPUT) print('Scanning dir(s)..');

foreach($RLS_DIRS as $path)
{
    transverse_dir($path);
}

if($OUTPUT) print("..done\n\n");

// Prepare to create links..
// Copies the backup .vfs file and names it as a temp file..
copy($RAIDENFTPD_VFS_PATH.'\\'.$RAIDENFTPD_VFS_PRESCRIPT_VER, $RAIDENFTPD_VFS_PATH.'\\'.$RAIDENFTPD_VFS.'.temp');

// Open the temp .vfs file and prepare to add entries to it..
$VFS_FP = fopen($RAIDENFTPD_VFS_PATH.'\\'.$RAIDENFTPD_VFS.'.temp', "a");
// fputs($VFS_FP, "\n");

// Create artist links..
if(isset($ALPHA_DIR))
{
    if($OUTPUT) print("Creating artist links...\n\n");
    
    fputs($VFS_FP, $ALPHA_DIR.'|'.$ALPHA_VFS_DIR.'|'.$VFS_OWNER.'|'.$VFS_OWNER_GROUP.'|'.$VFS_CHMOD."|r|0|0|0|0|0|\n");
    $create_link_result = create_alpha_links();   
}

// Create genre links..
if(isset($GENRE_DIR) && !empty($GENRE_DIR) && ($create_link_result))
{
    if($OUTPUT) print("Creating genre links...\n\n");
    
    fputs($VFS_FP, $GENRE_DIR.'|'.$GENRE_VFS_DIR.'|'.$VFS_OWNER.'|'.$VFS_OWNER_GROUP.'|'.$VFS_CHMOD."|r|0|0|0|0|0|\n");
    $create_link_result = create_genre_links();
}
    
// Create group links..
if(isset($GROUP_DIR) && !empty($GROUP_DIR) && ($create_link_result))
{
    if($OUTPUT) print("Creating group links...\n\n");
    
    fputs($VFS_FP, $GROUP_DIR.'|'.$GROUP_VFS_DIR.'|'.$VFS_OWNER.'|'.$VFS_OWNER_GROUP.'|'.$VFS_CHMOD."|r|0|0|0|0|0|\n"); 
    $create_link_result = create_group_links();
}

// Create year links
if(isset($YEAR_DIR) && !empty($YEAR_DIR) && ($create_link_result))
{
    if($OUTPUT) print("Creating year links...\n\n");
    
    fputs($VFS_FP, $YEAR_DIR.'|'.$YEAR_VFS_DIR.'|'.$VFS_OWNER.'|'.$VFS_OWNER_GROUP.'|'.$VFS_CHMOD."|r|0|0|0|0|0|\n"); 
    $create_link_result = create_year_links();
}

// Overwrite the current site .vfs with the new .vfs with the mp3links (the temp vfs).
fclose($VFS_FP);
unlink($RAIDENFTPD_VFS_PATH.'\\'.$RAIDENFTPD_VFS);
copy($RAIDENFTPD_VFS_PATH.'\\'.$RAIDENFTPD_VFS.'.temp', $RAIDENFTPD_VFS_PATH.'\\'.$RAIDENFTPD_VFS);
unlink($RAIDENFTPD_VFS_PATH.'\\'.$RAIDENFTPD_VFS.'.temp');

// Output stats information at the end..
if($OUTPUT)
{
    if($create_link_result) {
        print("\n\n==A total of ".$g_link_total." links created!\n\n");
    } else if(!$create_link_result) {
        print("\n\n  ERROR!\n\n  There was an error creating the dirs.\n  Make sure you have set your paths correctly!\n\n");
    } else if($create_link_result == VFS_LIMIT_REACHED) {
        print("\n\n  VFS LIMIT REACHED!\n\n==A total of ".$g_link_total." links created!\n\n");
    }
}

//
// MAIN PROGRAM LOOP END
//
/////////////////////////////////////////
?>